/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * locale.h: locale language support
 */


#ifndef __LOCALE_H
#ifdef __cplusplus
extern "C" {
#endif
#define __LOCALE_H

struct lconv {
    /* non monetary numeric values  */
    char	*decimal_point;	
    char	*thousands_sep;	
    char	*grouping;		/* wierd */
    
    /* for monetary values */
    char	*mon_decimal_point;
    char	*mon_thousands_sep;
    char	*mon_grouping;
    char	*int_curr_symbol;	/* e.g NOK in Norway */
    char	*currency_symbol;	/* e.g Kr in Norway */
    char	*positive_sign;		/* e.g "CR"/"+"/"" 	*/
    char	*negative_sign;		/* e.g "DB"/"-"		*/
    char	p_cs_precedes;	
    char	p_sep_by_space;
    char	p_sign_posn;
    char	n_cs_precedes;
    char	n_sep_by_space;
    char	n_sign_posn;
    char	int_frac_digits;	
    char	frac_digits;
};

struct lconv	*localeconv(void);
char *setlocale(int, const char *);

#define LC_ALL      0
#define LC_COLLATE  1
#define LC_CTYPE    2
#define LC_MONETARY 3
#define LC_NUMERIC  4
#define LC_TIME     5
#define LC_NLOCALE  6
#ifdef __cplusplus
}
#endif
#endif
