/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * pmon.h: MIPS SDE / LSI Logic pmcc compatibility 
 *
 * Including this header file allows a program written for LSI Logic's 
 * pmcc compilation system and pmon libraries, to be compiled and
 * linked with MIPS SDE. 
 */


#define STDIN		STDIN_FILENO
#define STDOUT		STDOUT_FILENO

#define strequ(s0,s1)	(strcmp((s0),(s1)) == 0)
#define striequ(s0,s1)	(strcasecmp((s0),(s1)) == 0)

#define randn(n)	((rand()>>8)%((n)+1))

/*
 * Call the PMON ROM's i/o routines, rather then using MIPS SDE i/o, so
 * that we can keep the executable small.
 */
#define read		pmon_read
#define write		pmon_write
#define open		pmon_open
#define close		pmon_close
#define ioctl		pmon_ioctl
#define printf		pmon_printf
#define vsprintf	pmon_vsprintf
#define ttctl		pmon_ttctl
#define getenv		pmon_getenv
#define onintr		pmon_onintr
#define flush_cache	pmon_flush_cache
#define __exception	pmon__exception
#define adr2symoff	pmon_adr2symoff
#define sym2adr		pmon_sym2adr

/* ATMizer specific */
#define write_iram(dst,src,n) iram_write((dst),(src),(n))

#include <unistd.h>
#include <string.h>
