/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * ieee754.h : MIPS IEEE floating point definitions
 */


#ifndef IEEE754

/*
 * Machines supporting ANSI/IEEE Std 754-1985
 * not yet complete
*/
#define IEEE754 1985


#define DBL_EMIN	(-1023)
#define DBL_EMAX	1023
#define DBL_EBIAS	1023
#define DBL_EXPLEN	11
#define DBL_FRALEN	52
#define DBL_MAXINT	??		/* max int can store */

#define FLT_EMIN	(-126)
#define FLT_EMAX	127
#define FLT_EBIAS	127
#define FLT_EXPLEN	8
#define FLT_FRALEN	23
#define FLT_MAXINT	??		/* max int can store */

#define LDBL_EMIN	DBL_EMIN
#define LDBL_EMAX	DBL_EMAX
#define LDBL_EBIAS	DBL_EBIAS
#define LDBL_EXPLEN	DBL_EXPLEN
#define LDBL_FRALEN	DBL_FRALEN
#define LDBL_MAXINT	DBL_MAXINT

#endif /* IEEE754 */


