/*
 * Copyright (c) 1998-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * mips/types.h : SDE basic type definitions for MIPS
 */


#ifndef __MACHINE_TYPES_H_

#define __MACHINE_TYPES_H_

#ifndef __ASSEMBLER__

#include <machine/int_types.h>

/* Backwards compatibility */
#ifndef	int8_t
typedef	__int8_t	int8_t;
#define	int8_t		__int8_t
#endif
#ifndef	uint8_t
typedef	__int8_t	uint8_t;
#define	uint8_t		__uint8_t
#endif
#ifndef	u_int8_t
typedef	__int8_t	u_int8_t;
#define	u_int8_t	__uint8_t
#endif
#ifndef	int16_t
typedef	__int16_t	int16_t;
#define	int16_t		__int16_t
#endif
#ifndef	uint16_t
typedef	__int16_t	uint16_t;
#define	uint16_t	__uint16_t
#endif
#ifndef	u_int16_t
typedef	__int16_t	u_int16_t;
#define	u_int16_t	__uint16_t
#endif
#ifndef	int32_t
typedef	__int32_t	int32_t;
#define	int32_t		__int32_t
#endif
#ifndef	uint32_t
typedef	__int32_t	uint32_t;
#define	uint32_t	__uint32_t
#endif
#ifndef	u_int32_t
typedef	__int32_t	u_int32_t;
#define	u_int32_t	__uint32_t
#endif
#ifdef __GNUC__
#ifndef	int64_t
typedef	__int64_t	int64_t;
#define	int64_t		__int64_t
#endif
#ifndef	uint64_t
typedef	__int64_t	uint64_t;
#define	uint64_t	__uint64_t
#endif
#ifndef	u_int64_t
typedef	__int64_t	u_int64_t;
#define	u_int64_t	__uint64_t
#endif
#endif

/* The longest/most efficient integer register type. */
#if __mips64
typedef __int64_t 	    register_t;
#else
typedef __int32_t 	    register_t;
#endif

#endif /* ! __ASSEMBLER__ */

#endif /* __MACHINE_TYPES_H_ */
