/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * pthread/unistd.h : POSIX Threads definitions
 */


#ifndef __PTHREAD_UNISTD_H
#define __PTHREAD_UNISTD_H

#define _POSIX_THREADS
#define _POSIX_THREAD_ATTR_STACKSIZE
#define _POSIX_THREAD_ATTR_STACKADDR
#define _POSIX_THREAD_PRIORITY_SCHEDULING
#define _POSIX_THREAD_PRIO_PROTECT
#define _POSIX_THREAD_PRIO_INHERIT
#define	_POSIX_THREAD_SAFE_FUNCTIONS
#undef	_POSIX_THREAD_PROCESS_SHARED

/* extra "non-posix" functions */
#define _POSIX_THREAD_MUTEX_TYPE_NP
#define _POSIX_THREAD_ATTR_NAME_NP
#define _POSIX_THREAD_DOORBELL_NP

/* These are POSIX.4 but we implement them too */
#define _POSIX_TIMERS
#define _POSIX_SEMAPHORES
#define _POSIX_MESSAGE_PASSING
#define _POSIX_REALTIME_SIGNALS

/* For sysconf() */
#define _SC_THREADS			(300+1)
#define _SC_THREAD_SAFE_FUNCTIONS	(300+2)
#define _SC_THREAD_THREADS_MAX		(300+3)
#define _SC_THREAD_ATTR_STACKADDR	(300+4)
#define _SC_THREAD_ATTR_STACKSIZE	(300+5)
#define _SC_THREAD_PROCESS_SHARED	(300+6)
#define _SC_THREAD_PRIORITY_SCHEDULING	(300+7)
#define _SC_THREAD_DESTRUCTOR_ITERATIONS (300+8)
#define _SC_THREAD_STACK_MIN		(300+9)
#define _SC_THREAD_PRIO_INHERIT		(300+10)
#define _SC_THREAD_PRIO_PROTECT		(300+11)
#define _SC_THREAD_KEYS_MAX		(300+12)

#endif /* __PTHREAD_UNISTD_H */
