/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * sys/posix.h: POSIX version numbers
 */


#ifndef __SYS_POSIX_H
#define __SYS_POSIX_H

#ifndef _POSIX_C_SOURCE
#if defined(_POSIX_SOURCE)
#define _POSIX_C_SOURCE 198808L
#else
/*#define _POSIX_C_SOURCE 0*/
#endif
#endif /* !_POSIX_C_SOURCE */

/* 
 * 198808L	POSIX.1,FIPS-151-1 
 * 199009L	POSIX.1,FIPS-151-2
 * 199309L	POSIX.4
 * 199506L	POSIX.4a, POSIX.1c (threads)
 */
#define _POSIX_VERSION 199506L

#if _POSIX_C_SOURCE > _POSIX_VERSION
#error _POSIX_C_SOURCE < _POSIX_VERSION
#endif

#define _POSIX_ASYNC_IO		-1
#define _POSIX_CHOWN_RESTRICTED	-1
#define _POSIX_NO_TRUNC		0
#define _POSIX_PRIO_IO		-1
#define _POSIX_SYNC_IO		-1

#undef _POSIX_ASYNCHRONOUS_IO
#undef _POSIX_FSYNC
#undef _POSIX_JOB_CONTROL
#undef _POSIX_MAPPED_FILES
#undef _POSIX_MEMLOCK
#undef _POSIX_MEMLOCK_RANGE
#undef _POSIX_MEMORY_PROTECTION
#undef _POSIX_MESSAGE_PASSING
#undef _POSIX_PRIORITIZED_IO
#undef _POSIX_PRIORITY_SCHEDULING
#undef _POSIX_REALTIME_SIGNALS
#undef _POSIX_POLL
#undef _POSIX_SELECT
#undef _POSIX_SEMAPHORES
#undef _POSIX_SAVED_IDS
#undef _POSIX_SHARED_MEMORY_OBJECTS
#undef _POSIX_SYNCHRONIZED_IO
#undef _POSIX_TIMERS

#define _POSIX_SYNC_IO		-1
#define _POSIX_ASYNC_IO		-1
#define _POSIX_PRIO_IO		-1

/* extensions */
#include <pthread/unistd.h>

#endif /* __SYS_POSIX_H */
