#
# ATMRT/sbd.mk: LSI Logic ATMizer R/T
#
# This board is fitted with the L64360
#

SBDDIRS		=.
SBDFLAGS  	=-DATMRT
CPU	  	=r3k
CPUVARIANT	=l64360
CACHES		=
WPOINTS		=r3k
TLB		=no
FPU		=no

# ROM base addresses (cached and uncached)
# Note the unusual L64360 ROM location (on secondary port)
ROM_C		=a0c00000
ROM_U		=a0c00000
ROM_SZ		=100000

# RAM base addresses (cached and uncached) for rommable progs
# Note that we use the first 128Kb SRAM region (on secondary port)
RAM_U		=a0d00000
RAM_C		=a0d00000

#
# Base address for downloadable programs (cached & uncached)
#
# Note: this uses the 512 Kb shared memory on the host port, 
# to ensure that there is enough space (some of the bigger
# example programs can overflow the 128Kb on the secondary port).
#
# If you are writing a program which needs to use the host port
# as real shared memory, then you'll need to specify a0d80000
# as the load address in your Makefile (e.g RAMLDFLAGS=-Ttext a0d80000).
#
DLBASE_C	=a0800020
DLBASE_U	=a0800020

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx sbdiram.c
SBDLOW		=sbdreset.o sbdser.o sbdmisc.o
SBDOBJ		=sbdser.o sbdmisc.o sbdiram.o s2681clk.o 

MONITOR		=pmon
