#
# IDT341/sbd.mk: IDT 79RS341 board in big-endian mode
#
# This board only accepts an R3041 cpu.
#
# When we get to see one of these boards, we will write the
# ROM support code.  Until then we only provide enough support
# for downloadable programs.
#

SBDDIRS		=../IDT341
SBDFLAGS  	=-DIDT341
CPU	  	=r3k
CPUVARIANT	=r3041
ENDIAN		=-EB
FPU		=no
ISA		=-mips1

SBDSRC		=sbdser.sx sbdmisc.sx 
#SBDLOW		= we don't have any rom startup code yet
SBDOBJ		=sbdser.o sbdmisc.o s2681clk.o
MONITOR		=idtsim

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
