/*
 * Copyright (c) 1999-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * IDT361/sbdfrom.h: onboard FROM support for IDT 79RS361 board
 */


/* Board only supports AMD-style devices */
#define FROM_FAMILY_AMD		1
#define FROM_FAMILY_ATMEL	1

/* Fixed device geometry on this board */
#define FROM_WIDTH		1	/* dev width = word (8 bits) */

/* dummy versions, should be overridden */
#ifndef FROM_NCOLS
#define FROM_NCOLS		1
#define FROM_GROUP		1
#endif

/* "Variable" device geometry (only Am29F040 supported) */
/*#define FROM_SECSIZE(fcp)*/
#define FROM_DEVSIZE(fcp)	0x80000
#define FROM_DEVSIZE_LOG2(fcp)	19
#define FROM_NBANKS(fcp)	1

/* Define to enable debug messages */
/*#define FROM_DEBUG*/

/* Defined if code (in particular flash programming code) 
   will never executed be from the flash rom. */
/*#define FROM_NEVER_SELF_PROGRAM*/

struct fromcookie;
struct fromcookie *	_sbd_bflashopen (paddr_t);
struct fromcookie *	_sbd_wflashopen (paddr_t);
