#
# IDT364B/sbd.mk: IDT 79S364 board with Cronus/RC32364 CPU (big-endian)
#
# NOTE: You must explicitly enable the on-chip timer interrupts 
# on this board!  See the board manual.
#

SBDDIRS		=../IDT364B
SBDFLAGS  	=-DIDT364 -DINET

CPU	  	=r4k
CP0	  	=r4k
CACHES		=rc32
WPOINTS	  	=r4k
FPU		=no
CPUVARIANT	=rc3236x
ISA		=-mips32

ENDIAN		=-EB

MONITOR		=idtsim

NVENV		=nvenv

SBDSRC		=sbdfreq.c sbdnvram.c sbdpanel.c \
		 sbdfrom.c sbdbfrom.c sbdhfrom.c sbdwfrom.c \
		 sbdmisc.sx sbdreset.sx sbdser.sx

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdser.o sbdmisc.o sbdfreq.o sbdnvram.o sbdpanel.o \
		 sbdfrom.o sbdbfrom.o sbdhfrom.o sbdwfrom.o \
		 r4kclock.o

SBDFEATURES	=flashdev

# XXX according to RC32364 Rev 1.2 Errata, we can't run cached yet!
# Rev 1.4 should be OK
#UNCACHED	=yes

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000

# alternative base addresses for explicit DRAM
#DLBASE_C	=80100000
#DLBASE_U	=a0100000
