#
# IDT381/sbd.mk: IDT 79RS381 board in big-endian mode
#
# This board can be fitted with any of the IDT R30x1 family.  
# The 3081 has an fpu, but the 3051 and 3041 do not.  If your
# board does not have a 3081 fitted, then change the definition
# of FPU to "no".
#
# When we get to see one of these boards, we will write the
# ROM support code.  Until then we only provide enough support
# for downloadable programs.
#

SBDDIRS		=../IDT381
SBDFLAGS  	=-DIDT381 -DINET
CPU	  	=r3k
CPUVARIANT	=
ENDIAN		=-EB
FPU		=maybe
ISA		=-mips1

SBDSRC		=sbdser.sx sbdmisc.sx 
#SBDLOW		= we don't have any rom startup code yet
SBDOBJ		=sbdser.o sbdmisc.o s2681clk.o
MONITOR		=idtsim

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
