/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * rs385.h: cpu board definitions for IDT RS385 eval board
 */


#define LOCAL_MEM	0x00000000 	/* local memory */
#define LOCAL_MEM_SIZE	0x400000	/* local memory size (4Mb max) */

#define CENT_BASE	0x00600000	/* centronics input fifo */
#define	TIMER_BASE	0x1f800000	/* i8254 timer */
#define USER_BASE	0x1fa00000	/* user expansion */
#define PROM_BASE	0x1fc00000	/* prom */
#define DUART_BASE	0x1fe00000 	/* S2681 duart */
#define DUART2_BASE	0x1ff00000 	/* S2681 duart #2? */

/* hardware interrupts (default settings) */
#define	INTR_TINT0	2	/* timer 0:	sint 0 */
#define	INTR_TINT1	3	/* timer 1:	sint 1 */
#define INTR_CENT	5	/* centronics:	int  3 */
#define INTR_DUART	7	/* duart:	int  5 */

/* S2681 uart defs */
#define S2681REGSZ	4
