#
# IDT385/sbd.mk: IDT 79RS385 board in big-endian mode
#
# This board can be fitted with any of the IDT R30x1 family.  
# The 3081 has an fpu, but the 3051 and 3041 do not.  If your
# board does not have a 3081 fitted, then change the definition
# of FPU to "no".
#

SBDDIRS		=../IDT385
SBDFLAGS  	=-DIDT385
CPU	  	=r3k
CPUVARIANT	=#e.g. '-Acpu(r3041)'
FPU		=maybe
ISA		=-mips1

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx sbdclock.c
SBDLOW		=sbdreset.o sbdser.o sbdmisc.o
SBDOBJ		=sbdser.o sbdmisc.o sbdclock.o
MONITOR		=idtsim

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
