#
# IDT465/sbd.mk: IDT 79S465 board with R4640/4650 CPU (big-endian)
#		 & 64-bit IDT/sim (this must match)
#

SBDDIRS		=../IDT465
SBDFLAGS  	=-DIDT465 -DINET

CPU	  	=r4k
TLB		=no
FPU		=single
CPUVARIANT	=r4640
# Change to ISA=-mips2 if 32-bit IDT/sim is fitted
ISA		=-mips3
ENDIAN		=-EB

MONITOR		=idtsim

NVENV		=nvenv

SBDSRC		=sbdfreq.c sbdmisc.sx sbdreset.sx sbdser.sx \
		 sbdnvram.c sbdtime.c \
		 #sbdfrom.c sbdbfrom.c sbdwfrom.c

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdser.o sbdmisc.o sbdfreq.o \
		 sbdnvram.o sbdtime.o r4kclock.o \
		 #sbdfrom.o sbdbfrom.o sbdwfrom.o

# Flash memory access is broken on this board
#SBDFEATURES	=flashdev

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000

# alternative for explicit DRAM
#DLBASE_C	=80200000
#DLBASE_U	=a0200000
