#
# MSIM32MTFL/sbd.mk: MIPSsim MIPS32r2, hard-float, multi-threading, little-endian
# CPUs: 34Kc
#
# RTPXlite doesn't support use of h/w FPU by more than one thread, so
# for now only soft-float is possible.
# 
# ThreadX can support h/w FPU, but that will need a different config.
#
include $(KITDIR)/mipssim/sbd.mk
CPU		=34kf
ISA		=-mips32r2
FPU		=maybe
ENDIAN	  	=-EL

# Supports ThreadX
THREADFEATURES	+=threadx

# Supports ThreadX applications with only 'main' entry-points
THREADFEATURES  +=tx_main

# Supports ThreadX applications using the EL POSIX layer with only
# 'main' entry-points
THREADFEATURES  +=tx_posix
