#ident "kit/NEC5074L/sbd.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1999-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * NEC5074/sbd.c: miscellaneous low-level board functions 
 */


#include <stddef.h>
#include <mips/cpu.h>
#include "sbd.h"

void *
ioport_map (unsigned int port)
{
    return PA_TO_KVA1 (ISAPORT_BASE(port));
}


unsigned char
inb (unsigned int port)
{
    return *(volatile unsigned char *) PA_TO_KVA1 (ISAPORT_BASE(port));
}

unsigned short
inw (unsigned int port)
{
    return *(volatile unsigned short *) PA_TO_KVA1 (ISAPORT_BASE(port));
}

unsigned long
inl (unsigned int port)
{
    return *(volatile unsigned long *) PA_TO_KVA1 (ISAPORT_BASE(port));
}

void
outb (unsigned int port, unsigned char val)
{
    *(volatile unsigned char *) PA_TO_KVA1 (ISAPORT_BASE(port)) = val;
    mips_wbflush ();
}

void
outw (unsigned int port, unsigned short val)
{
    *(volatile unsigned short *) PA_TO_KVA1 (ISAPORT_BASE(port)) = val;
    mips_wbflush ();
}

void
outl (unsigned int port, unsigned long val)
{
    *(volatile unsigned long *) PA_TO_KVA1 (ISAPORT_BASE(port)) = val;
    mips_wbflush ();
}
