#
# NEC5074L/sbd.mk: NEC DDB-Vrc5074 eval board
#
# Use -mips3 so as to support 64-bit exception handling and all
# 32 floating-point registers, but select -mgp32 (32-bit integer
# registers) to reduce stack overhead and prologue/epilogue time.
#

SBDDIRS		=../NEC5074L
SBDFLAGS  	=-DNEC5074 -DINET
KITFLAGS	=-DALGPMON
CPU	  	=r5k
ISA		=-mips4
FPU		=yes
PCI		=yes
ENDIAN	  	=-EL

NVENV		=nvenv

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx sbd.c \
		 sbdtod.c sbdfreq.c sbdclock.c \
		 sbdnvram.c sbdfrom.c flashrom.c \
		 pci_machdep.c

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdser.o sbdmisc.o sbd.o \
		 sbdtod.o sbdfreq.o sbdclock.o \
		 sbdnvram.o sbdfrom.o flashrom.o \
		 pci_machdep.o

SBDFEATURES	=flashdev

MONITOR		=pmon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80080000
DLBASE_U	=a0080000

# can't run cached from ROM
#ROM_C		=bfc00000
#UNCACHED	=yes
